//
//  Arbre.java
//  Triangulation
//
//  Created by Thomas Jannaud on 24/01/10.
//  Copyright 2010 Jannaud's Technical Company. All rights reserved.
//

import java.util.LinkedList;
import java.util.HashSet;

public class Arbre {
	monTriangle val;
	HashSet<Arbre> fils;
	Arbre pere;
	Arbre(monTriangle v) {
		val = v;
		fils = new HashSet<Arbre>();
		pere = null;
	}
	public monTriangle valeur() {
		return val;
	}
	public void ajoute_fils(monTriangle t) {
		Arbre a = new Arbre(t);
		a.pere = this;
		fils.add(a);
	}
	public boolean hasChildren() {
		return (fils.size() > 0);
	}
	public Arbre find(monPoint p) {
		Arbre arbre = this;
		while(arbre.hasChildren()) {
			for(Arbre gros_t : arbre.fils) {
				if (p.isIn(gros_t.valeur())) {
					arbre = gros_t;
					break;
				}
			}
			if (arbre.valeur() == null)
				break;
			if (!p.isIn(arbre.valeur()))
				System.out.println("ERREUR : on n'est pas sensé arrivé à ce niveau d'imbrication dans l'arbre englobant.\n" + arbre.valeur() + "\non cherchait :" + p);
		}
		return arbre;
	}
	public void kill(monTriangle t, monSegment s) {
		// System.out.println("kill cherche " + t.petittoString() + " avec segment " + s.toString());
		// tuer tous les triangles contenant t et ayant un segment s pour bord, sauf le dernier (plus petit) triangle
		LinkedList<Arbre> lifo_to_remove = new LinkedList<Arbre>();
		Arbre arbre = this;
		while(arbre.hasChildren()) {
		// System.out.println("kill regarde arbre :\n" + arbre.toString());
			// find the child
			for(Arbre gros_t : arbre.fils) {
			//	System.out.println("kill regarde fils :\n" + gros_t.toString());
				if (t.isIn(gros_t.val)) {
					arbre = gros_t;
					break;
				}
			}
			// System.out.println("fin boucle, on devrait avoir pris une décision");
			if (arbre.val == null)
				break;
			if (!t.isIn(arbre.val))
				System.out.println("ERREUR : on n'est pas sensé arrivé à ce niveau d'imbrication dans l'arbre englobant.\n" + arbre.valeur() + "\n on cherchait :" + t);
			if (!arbre.hasChildren())
				break;
			if (arbre.val.hasEdge(s))
				lifo_to_remove.addFirst(arbre);
		}

//		System.out.println("lifo finie");
		
		while(!lifo_to_remove.isEmpty()) {
			arbre = lifo_to_remove.poll();
//			System.out.println("kill is removing " + arbre.toString());
			for(Arbre a : arbre.fils)
				a.pere = arbre.pere;
			arbre.pere.fils.addAll(arbre.fils);
			arbre.pere.fils.remove(arbre);
		}
	}
	public void clear() {
		LinkedList<Arbre> lifo_to_remove = new LinkedList<Arbre>();
		lifo_to_remove.add(this);
		while(!lifo_to_remove.isEmpty()) {
			Arbre arbre = lifo_to_remove.poll();
			for(Arbre a : arbre.fils)
				lifo_to_remove.addFirst(a);
			arbre.fils.clear();
		}
	}
	private String espaces(int n) {
	if (n == 0)
		return "";
		char[] c = new char[n];
		for(int i = 0; i < n; i++)
			c[i] = ' ';
		return new String(c);
	}
	public String toString() {
		return toString(0);
	}
	public String toString(int n) {
		String s;
		String esp = espaces(n);
		if (val == null)
			s = esp + "arbre : val=null";
		else
			s = esp + "arbre : val=" + val.p[0].toString() + ", " + val.p[1].toString() + ", " + val.p[2].toString();
		if (fils.isEmpty())
			return s;
		s += "\n" + esp + "liste fils :";
		for(Arbre a : fils)
			s += "\n" + esp + a.toString(n + 2);
		return s;
	}
}
