//
//  monPoint.java
//  Triangulation
//
//  Created by Thomas Jannaud on 16/12/09.
//  Copyright 2009 Jannaud's Technical Company. All rights reserved.
//

import java.text.DecimalFormat;

public class monPoint {
	public double x, y;
	public monPoint(double xx, double yy) {x = xx; y = yy;}
	public double distanceSq(monPoint pt) { return (x - pt.x) * (x - pt.x) + (y - pt.y) * (y - pt.y);}
	public boolean isIn(monTriangle t) {
	for(int i = 0; i < 3; i++)
		if (equals(t.p[i]))
			return true;
		monVecteur v12 = new monVecteur(t.p[0], t.p[1]);
		monVecteur v2p = new monVecteur(t.p[1], this);
		monVecteur v23 = new monVecteur(t.p[1], t.p[2]);
		monVecteur v3p = new monVecteur(t.p[2], this);
		monVecteur v31 = new monVecteur(t.p[2], t.p[0]);
		monVecteur v1p = new monVecteur(t.p[0], this);
		if (t.isClockwise())
			return v12.isClockwise(v2p) && v23.isClockwise(v3p) && v31.isClockwise(v1p);
		else
			return !(v12.isClockwise(v2p) || v23.isClockwise(v3p) || v31.isClockwise(v1p));
	}
	public boolean equals(Object obj) {
		if (obj instanceof monPoint) {
			final monPoint p = (monPoint)(obj);
			return (x == p.x && y == p.y);
		}
		else
			return false;
	}
	public int hashCode() {
		return (int)(100.0 * (x + y));
	}
	public String toString() {
		return "" + hashCode();
	}
	public String coordonnees() {
		DecimalFormat nf = new DecimalFormat() ;
		nf.setMaximumFractionDigits(2);
		return "(" + nf.format(x) + ", " + nf.format(y) + ")";
	}
}
