//
//  monSegment.java
//  Triangulation
//
//  Created by Thomas Jannaud on 16/12/09.
//  Copyright 2009 Jannaud's Technical Company. All rights reserved.
//

import java.util.HashMap;

public class monSegment {
	public monPoint A, B;
	public monPoint p1, p2; // éventuels triangles attachés au segment
	public monSegment(monPoint aa, monPoint bb) {
		A = aa;
		B = bb;
		p1 = null;
		p2 = null;
	}
	public monSegment(monPoint aa, monPoint bb, monPoint pp1) {
		A = aa;
		B = bb;
		p1 = pp1;
		p2 = null;
	}
	public monSegment(monPoint aa, monPoint bb, monPoint pp1, monPoint pp2) {
		A = aa;
		B = bb;
		p1 = pp1;
		p2 = pp2;
	}
	
	public void replace(monPoint p, monPoint q) {
		if (p1 != null && p1.equals(p))
			p1 = q;
		else if (p2 != null && p2.equals(p))
			p2 = q;
		else
			System.out.println("ERREUR !!!!! replace " + p + " par " + q + "dans segment :" + this);
	}
	
	public void ajoute(monPoint p) {
		if (p1 == null)
			p1 = p;
		else if (p2 == null)
			p2 = p;
		else
			System.out.println("ERREUR : cherche à ajouter qqchose alors qu'il n'y a plus de place");
	}
	
	public boolean shouldFlip() {
		if (p1 == null || p2 == null)
			return false;
		monPoint a = A, c = B, b = p1, d = p2;
		monVecteur vad = new monVecteur(d, a);
		monVecteur vbd = new monVecteur(d, b);
		monVecteur vcd = new monVecteur(d, c);
		double determinant3D = 0.
		+ vad.x * vbd.y * vcd.norme2()
		+ vcd.x * vad.y * vbd.norme2()
		+ vbd.x * vcd.y * vad.norme2()
		- vad.x * vcd.y * vbd.norme2()
		- vcd.x * vbd.y * vad.norme2()
		- vbd.x * vad.y * vcd.norme2();
		return (monTriangle.isClockwise(a, b, c) ? (determinant3D < 0) : (determinant3D > 0));
	}
	public void flip(HashMap<monSegment, monSegment> segments, HashMap<monTriangle, monTriangle> triangles, Arbre old_triangles) {
		// on a un quadrilatère ABCD avec le segment BD en plus ; retirer BD et mettre AC
		monPoint b = A, d = B, a = p1, c = p2;
		monSegment sab = segments.get(new monSegment(a, b));
		monSegment sbc = segments.get(new monSegment(b, c));
		monSegment scd = segments.get(new monSegment(c, d));
		monSegment sda = segments.get(new monSegment(d, a));
		if (sab == null || sbc == null || scd == null || sda == null)
			System.out.println("ERREUR : un des segments n'y est pas.\nsab :\n" + f(sab) + "\nsbc\n" + sbc + "\nscd\n" + scd + "\nsda\n" + sda);
/*		
		System.out.println("***********************\non flippe : " + this + "\n--------------------liste des triangles avant.");
		nuagePoints.affiche(triangles);
		System.out.println("------------------------\nliste des segments avant");
		nuagePoints.affiche(segments);
*/		
		// attention !
		// certaines transformations affectent le hash
		// donc on retire les objets de la table de hashage et on les y remet après

		// mettre à jour les triangles englobants
		monTriangle tabd = new monTriangle(a, b, d), tbcd = new monTriangle(b, c, d);
		old_triangles.kill(tabd, this);
		old_triangles.kill(tbcd, this);
		
		// flipper les triangles
		// 1ere étape
		monTriangle t1 = triangles.remove(tabd);
		t1.replace(d, c);
		triangles.put(t1, t1);
		monTriangle t2 = triangles.remove(tbcd);
		t2.replace(b, a);
		triangles.put(t2, t2);
		
		// replace : ne modifie pas le hash
		t1.replace(this, sbc);
		t2.replace(this, sda);
		
		{		
			segments.remove(this);
			A = a; B = c; p1 = b; p2 = d;
			segments.put(this, this);
		}
		
		// replace : ne modifie pas le hash
//		System.out.println("replace de flip");
		sab.replace(d, c);
		sbc.replace(d, a);
		scd.replace(b, a);
		sda.replace(b, c);
		
		// flipper les triangles
		// 2nde étape
			t1.replace(sda, this);
			t2.replace(sbc, this);
/*		
		System.out.println("--------------------\nliste des triangles après.");
		nuagePoints.affiche(triangles);
		System.out.println("------------------------\nliste des segments après");
		nuagePoints.affiche(segments);
		System.out.println("\nfin flippe\n************************");*/
	}
	public int hashCode() {
		return A.hashCode() + B.hashCode();
	}
	public boolean equals(Object obj) {
		if (obj instanceof monSegment) {
			final monSegment p = (monSegment)(obj);
			return (A.equals(p.A) && B.equals(p.B)) || (A.equals(p.B) && B.equals(p.A));
		}
		else
			return false;
	}
	public String toString() {
		return "(A:" + f(A) + ", B:" + f(B) + "), (p1:" + f(p1) + ", p2:" + f(p2) + ")";
	}
	private String f(Object o) {
		if (o == null)
			return "null";
		return o.toString();
	}
	public boolean aPourSommet(monPoint p) {
		return (p.equals(A) || p.equals(B));
	}
}