//
//  nuagePoints.java
//  Triangulation
//
//  Created by Thomas Jannaud on 16/12/09.
//  Copyright 2009 Jannaud's Technical Company. All rights reserved.
//

import java.util.*;

public class nuagePoints {
	private Random generator = new Random();
	public LinkedList<monPoint> points;
	public HashMap<monTriangle, monTriangle> triangles;
	private Arbre old_triangles;
	public HashMap<monSegment, monSegment> segments;
	public Tableau<monPoint> enveloppe_convexe;
	public nuagePoints() {
		points = new LinkedList<monPoint>();
		enveloppe_convexe = new Tableau<monPoint>();
		triangles = new HashMap<monTriangle, monTriangle>();
		segments = new HashMap<monSegment, monSegment>();
		old_triangles = new Arbre(null);
	}
	public void clear() {
		points.clear();
		enveloppe_convexe.clear();
		triangles.clear();
		segments.clear();
		old_triangles.clear();
	}
	public void ajouter(double x, double y) {
		monPoint p = new monPoint(x, y);
		System.out.println("ajoute " + p.coordonnees() + " -> " + p);
		points.add(p);
		System.out.println("nuage now has " + points.size() + " points");
		/*		System.out.println("--------------------\nliste des triangles avant");
		 affiche(triangles);
		 System.out.println("------------------------\nliste des segments avant");
		 affiche(segments);*/
		insereInTriangulation(p);
		/*		System.out.println("--------------------\nliste des triangles après insertion");
		 affiche(triangles);
		 System.out.println("------------------------\nliste des segments après insertion");
		 affiche(segments);*/
	}
	public void ajouter(int n) {
		System.out.println("before big add, nuage has " + points.size() + " points");
		for(int i = 0; i < n; i++) {
			double x = generator.nextDouble();
			double y = generator.nextDouble();
			monPoint p = new monPoint(x, y);
			points.add(p);
			insereInTriangulation(p);
		}
		System.out.println("nuage now has " + points.size() + " points");
		System.out.println(segments.size() + " segments");
	}
	private void insereInTriangulation(monPoint p) {
		if (points.size() < 3)
			return;
		else if (points.size() == 3) {
			Iterator<monPoint> it = points.iterator();
			monPoint p1 = it.next();
			monPoint p2 = it.next();
			monPoint p3 = it.next();
			monSegment s12 = new monSegment(p1, p2, p3);
			monSegment s23 = new monSegment(p2, p3, p1);
			monSegment s31 = new monSegment(p3, p1, p2);
			monTriangle t = new monTriangle(p1, p2, p3, s12, s23, s31);
			triangles.put(t, t);
			segments.put(s12, s12);
			segments.put(s23, s23);
			segments.put(s31, s31);
			old_triangles.ajoute_fils(t);
			if (t.isClockwise()) {
				enveloppe_convexe.add(p1); enveloppe_convexe.add(p2); enveloppe_convexe.add(p3);
			}
			else {
				enveloppe_convexe.add(p1); enveloppe_convexe.add(p3); enveloppe_convexe.add(p2);
			}
		}
		else {
			// old_triangles : principe des boites englobantes pour les triangles
			Arbre arbre = old_triangles.find(p);
			
			// cas 1 : insertion d'un point dans l'enveloppe convexe du nuage, donc dans un des triangles
			if (arbre.valeur() != null && !arbre.hasChildren() && p.isIn(arbre.valeur())) {
				monTriangle t = triangles.get(arbre.valeur());
//				System.out.println("$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$\ninserting " + p + " dans triangle\n" + t);
				monSegment[] nouv_segs = new monSegment[6];
				for(int i = 0; i < 3; i++) {
					nouv_segs[i] = t.segments[i];
					nouv_segs[i].replace(t.p[(i + 2) % 3], p);
				}
				nouv_segs[3] = new monSegment(t.p[0], p, t.p[1], t.p[2]);
				nouv_segs[4] = new monSegment(t.p[1], p, t.p[0], t.p[2]);
				nouv_segs[5] = new monSegment(t.p[2], p, t.p[0], t.p[1]);
				
				monTriangle t01p = new monTriangle(t.p[0], t.p[1], p, nouv_segs[0], nouv_segs[4], nouv_segs[3]);
				monTriangle t12p = new monTriangle(t.p[1], t.p[2], p, nouv_segs[1], nouv_segs[5], nouv_segs[4]);
				monTriangle t20p = new monTriangle(t.p[2], t.p[0], p, nouv_segs[2], nouv_segs[3], nouv_segs[5]);
				
				arbre.ajoute_fils(t01p);
				arbre.ajoute_fils(t12p);
				arbre.ajoute_fils(t20p);
				
				triangles.remove(t);
				
				triangles.put(t01p, t01p);
				triangles.put(t12p, t12p);
				triangles.put(t20p, t20p);
				
				segments.put(nouv_segs[3], nouv_segs[3]);
				segments.put(nouv_segs[4], nouv_segs[4]);
				segments.put(nouv_segs[5], nouv_segs[5]);
				
				Queue<monSegment> l = new LinkedList<monSegment>();
				for(int i = 0; i < 6; i++)
					l.add(nouv_segs[i]);
				checkGoodTriangulation(l);
//				System.out.println("--------------------\ninsertion dans un autre triangle terminée.");
			}
			else {
				// cas 2 : on doit agrandir l'enveloppe convexe (horaire !)
//				System.out.println("-------------------\nhors enveloppe.\nenveloppe :");
				int n = enveloppe_convexe.size();
/*				for(int i = 0; i < n; i++)
					System.out.println("point " + i + " : " + enveloppe_convexe.get(i));*/
				int it_fin_droite = find_extremum_dicho(p, 1, enveloppe_convexe);
				int it_fin_gauche = find_extremum_dicho(p, -1, enveloppe_convexe);
				if (it_fin_droite < it_fin_gauche)
					it_fin_droite += n;
//				System.out.println("it droite : "  + it_fin_droite + " -> " + enveloppe_convexe.get(it_fin_droite % n));
//				System.out.println("it gauche : "  + it_fin_gauche + " -> " + enveloppe_convexe.get(it_fin_gauche));
				
				Queue<monSegment> l = new LinkedList<monSegment>();
				
				monSegment sadj = null;
				for(int i = it_fin_gauche; i < it_fin_droite; i++) {
					monPoint p1 = enveloppe_convexe.get(i % n), p2 = enveloppe_convexe.get((i + 1) % n);
					monSegment s = segments.get(new monSegment(p1, p2));
					l.add(s);
					s.ajoute(p);
					if (sadj == null) {
						sadj = new monSegment(p1, p, p2);
						segments.put(sadj, sadj);
						l.add(sadj);
					}
					monSegment snouv;
					if (i < (it_fin_droite - 1))
						snouv = new monSegment(p2, p, p1, enveloppe_convexe.get((i + 2) % n));
					else
						snouv = new monSegment(p2, p, p1);
					segments.put(snouv, snouv);
					l.add(snouv);
					monTriangle t = new monTriangle(p1, p, p2, sadj, snouv, s);
					triangles.put(t, t);
					old_triangles.ajoute_fils(t);
					sadj = snouv;
				}
				// retirer les anciens points
				if (it_fin_droite < n) {
					enveloppe_convexe.removeRange(it_fin_gauche + 1, it_fin_droite);
					enveloppe_convexe.add(it_fin_gauche + 1, p);
				}
				else {
					enveloppe_convexe.removeRange(it_fin_gauche + 1, n);
					enveloppe_convexe.removeRange(0, it_fin_droite - n);
					enveloppe_convexe.add(0, p);
				}
				checkGoodTriangulation(l);
			}
		}
//		System.out.println("old triangles : " + old_triangles.toString());
//		affiche(segments);
	}
	
	private void checkGoodTriangulation(Queue<monSegment> aChecker) {
		while(!aChecker.isEmpty()) {
			monSegment s = aChecker.poll();
			if (s.shouldFlip()) {
//				System.out.println("on flippe " + s);
				s.flip(segments, triangles, old_triangles);
				if (!segments.containsKey(new monSegment(s.A, s.p1)))
					System.out.println("truc bizarre");
				if (!segments.containsKey(new monSegment(s.p1, s.B)))
					System.out.println("truc bizarre");
				if (!segments.containsKey(new monSegment(s.B, s.p2)))
					System.out.println("truc bizarre");
				if (!segments.containsKey(new monSegment(s.p2, s.A)))
					System.out.println("truc bizarre");
				aChecker.add(segments.get(new monSegment(s.A, s.p1)));
				aChecker.add(segments.get(new monSegment(s.p1, s.B)));
				aChecker.add(segments.get(new monSegment(s.B, s.p2)));
				aChecker.add(segments.get(new monSegment(s.p2, s.A)));
			}
		}
	}
	public static void affiche(HashMap liste) {
		System.out.println("liste de taille " + liste.size());
		for(Object s : liste.keySet())
			System.out.println(s);
	}
	
	private int find_extremum_dicho(monPoint p, int sens, ArrayList<monPoint> liste) {
		double signe = (sens > 0) ? 1.0 : -1.0;
		int next = 1;
		int n = liste.size();
		int i = 0;
		for(int time = 0; time < 3; time++) {
			int d = power2(n);
			boolean canuse1twice = true;
			while (d != 0) {
//				System.out.println("entree : i=" + i + ", d=" + d);
				monPoint p1 = liste.get(i);
				monPoint p2 = liste.get((i + 1) % n);
				monPoint p3 = liste.get((i + n - 1) % n);
				monVecteur v1 = new monVecteur(p, p1);
				monVecteur v2 = new monVecteur(p1, p2);
				monVecteur v3 = new monVecteur(p1, p3);
//				System.out.println("det1 = " + v1.determinant(v2) + "    et det2 = " + v1.determinant(v3));
				if (v1.determinant(v2) * signe <= 0 && v1.determinant(v3) * signe <= 0) {
//					System.out.println("retour direct de : " + i);
					return i;
				}
				if (v1.determinant(v2) * signe >= 0 && v1.determinant(v3) * signe >= 0) // l'autre pole
					next = sens;
				else if (v1.determinant(v2) >= 0)
					next = sens;
				else
					next = -sens;
				i += d * next;
				d /= 2;
				if (d == 0 && canuse1twice) {
					d = 1;
					canuse1twice = false;
				}
				if (i < 0)
					i += n;
				if (i >= n)
					i -= n;
//				System.out.println("sortie : i=" + i + ", d=" + d);
			}
			if (2 * power2(n) == n)
				i++;
			if (i == 0)
				i++;
		}
		return find_linear(p, sens, liste);
	}
	private int find_linear(monPoint p, int sens, ArrayList<monPoint> liste) {
		double signe = (sens > 0) ? 1.0 : -1.0;
		int n = liste.size();
		for(int i = 0; i < n; i++) {
				monPoint p1 = liste.get(i);
				monPoint p2 = liste.get((i + 1) % n);
				monPoint p3 = liste.get((i + n - 1) % n);
				monVecteur v1 = new monVecteur(p, p1);
				monVecteur v2 = new monVecteur(p1, p2);
				monVecteur v3 = new monVecteur(p1, p3);
				if (v1.determinant(v2) * signe <= 0 && v1.determinant(v3) * signe <= 0) {
//					System.out.println("retour direct (lineaire) de : " + i);
					return i;
				}
		}
		System.out.println("ERREUR : ne devrait pas être là !!");
		return 0;
	}
	private int power2(int n) {
		int a = 1;
		while (a < n)
			a = a << 1;
		a = (a >> 1);
		return a;
	}
}

class Tableau<V> extends ArrayList<V> {
	Tableau() {
		super();
	}
	public void removeRange(int a, int b) {
		super.removeRange(a, b);
	}
}